;
; 	GUI - ported from MMBASIC on the Micromite, code originally by user CaptainBoing on
;	http://www.fruitoftheshed.com/MMBasic.A-Simple-GUI-pack.ashx
;
;	coded and compiled in Prog8 version 9.4 for the Commander X16
;	S. Yockey - September 2023
;
%import gfx2
%import floats
%import conv
%import syslib
%import string

main {

	;for mouse functions
	uword @requirezp mx 
	uword @requirezp my 
	
	;bool ProcessTouch 
	ubyte btn
	byte P				;next available object
	str obstr = iso:"Obj "
	uword Xt
	uword Yt
	
	
	const ubyte Objs = 20
	const ubyte CGY = 26
	const ubyte CGH = 29
	
	sub start() {
	
		byte q
		byte f
		ubyte m
		uword t
		uword i
		
		gfx2.screen_mode(4)
		gfx2.text_charset(1)
		gfx2.fillrect(0,0,320,240,CGH)
		
		init()
	
		cx16.mouse_config(1, 320/8, 240/8)
		
		;set clock to all zeros to use as timer
		cx16.clock_set_date_time(0,0,0,0)
		
	;draw the progress bars for increasing value
    for i in 0 to 300 step 5 {   
        ObjVSet(61,i)
        ObjDraw(61)
        ObjVSet(62,i)
        ObjDraw(62)
        sys.waitvsync() ;wait(1)

    }
    
    ;get elapsed time and updates text of object 52
    time()
    
    ObjDraw(52)
    
    void ObjPSet(29,%00001100)
		ObjDraw(29)
		
		repeat {
		
			if GetTouch() {									; if left button is pressed
				q = ProcessTouch()							; process it
				;if q != -1 {								; if no object is where press occurred, ignore touch
				;	gfx2.txdata[q](2,10,0,&obstr)
				
				;}
			
			
			
			;get the value from the slider and update a text box
			when q {						
				70,71 -> {									;need to include frame, if one is used around a slider!
					for m in 50 to 52 {						;the three text boxes
				
						f = ObjFind(m)						;find internal ID of object m
						t = ObjVGet(71)						;get value of object 71 (slider)
						conv.str_uw(t)						;convert value (uword) to string
						object.txdata[f] = conv.string_out	;assign string to object m's text variable
						ObjDraw(m)							;update object m
					}
				}
				
				23 -> {
					sys.reset_system()
				
				}
					
				}
			}

	
		}
	
}


 sub init() {

	byte res

;Buttons
	res = ObjDef(21,1,10,10,80,30,iso:"Save",CGH,2,1) as byte
	res = ObjDef(23,1,10,50,80,30,iso:"Exit",CGH,0,1) as byte
	
;Checkboxes
	res = ObjDef(25,3,10,100,0,0,iso:"Checked",0,0,0) as byte
	res = ObjDef(27,3,10,120,0,0,iso:"Disabled",0,0,0) as byte
	res = ObjDef(29,3,10,140,0,0,iso:"Not Checked",0,0,0) as byte
	
;Radio boxes (in a frame)
	res = ObjDef(40,2,170,100,0,0,iso:"Red",1,52,0) as byte
	res = ObjDef(41,2,170,120,0,0,iso:"Green",1,115,0) as byte
	res = ObjDef(42,2,170,140,0,0,iso:"Blue",1,199,0) as byte
;frame
	res = ObjDef(39,9,165,90,80,65,iso:"Colors",0,0,4) as byte
	
;text boxes
	res = ObjDef(50,5,160,10,150,15,iso:"L Text black frame",115,0,4) as byte
	res = ObjDef(51,5,160,35,150,15,iso:"C Text no frame",CGH,0,16) as byte
	res = ObjDef(52,5,160,60,150,15,iso:"              ",1,0,34) as byte
	
;progress bar
	res = ObjDef(61,8,10,210,300,20,"",0,300,$c702) as byte
	res = ObjDef(62,8,270,90,40,65,"",0,65,$3412) as byte
	
;Slider
	res = ObjDef(71,4,20,180,100,0,"",0,300,51) as byte
	res = ObjDef(70,9,10,170,100,30,iso:"",0,0,1) as byte

;set the properties of the object, visibility, enabled etc...
	res = ObjPSet(21,%00001100)
	res = ObjPSet(23,%00001100)
	res = ObjPSet(25,%00101100)
	res = ObjPSet(27,%00101000)
	res = ObjPSet(29,%00101000)
	res = ObjPSet(39,%00001100)
	res = ObjPSet(40,%00101100)
	res = ObjPSet(41,%00101100)
	res = ObjPSet(42,%00001000)
	res = ObjPSet(50,%00001100)
	res = ObjPSet(51,%00001100)
	res = ObjPSet(52,%00001100)
	res = ObjPSet(61,%00001100)
	res = ObjPSet(62,%00001100)
	res = ObjPSet(70,%00001100)
	res = ObjPSet(71,%00001100)

;nothing appears on the screen until you draw the object
;this allows multiple updates at once and you control when it happens
	ObjDraw(21)
	ObjDraw(23)
	ObjDraw(25)
	ObjDraw(27)
	ObjDraw(29)
	ObjDraw(39)
	ObjDraw(40)
	ObjDraw(41)
	ObjDraw(42)

	
	ObjDraw(50)
	ObjDraw(51)
	ObjDraw(52)
	ObjDraw(61)
	ObjDraw(62)
	ObjDraw(70)
	ObjVSet(71,150)
	ObjDraw(71)
}

; non GUI code, strictly for the demo program
sub time() {
		ubyte seconds
		ubyte minutes
		ubyte hours
		str time_text1 = iso:"R    " ;"seconds"
		str time_text2 = iso:"seconds"
		str time_text3 =     "                " 
		ubyte n
		ubyte l
		ubyte q
		
		
		%asm{{
			jsr $ff50
			}}
		

		seconds = cx16.r2H
		minutes = cx16.r2L
		hours = cx16.r1H
    		
					conv.str_ub(seconds)						;convert value to string
				
					for n in 0 to string.length(time_text1) {
						time_text3[n] = time_text1[n] 
						l += 1 }
					
						
					l = string.length(time_text3)
					q = l
					for n in 0 to string.length(time_text2) {
						time_text3[n+l] = time_text2[n] 
						q += 1 }
						
					for n in 0 to string.length(conv.string_out)-1 {
						time_text3[n+2] = conv.string_out[n] }
						
					;time_text3[q] = 0
						
						
					
					object.txdata[11] = time_text3  ;+ &time_text2	;assign string to object m's text variable
			
		       		
				
	}

;fetches object value, which depends on object type. Might be whether or not object is selected/checked or actual numerical value.	
	sub ObjVGet(ubyte id) -> uword {
		byte n
		
		n = ObjFind(id)
		if n > -1 {
			when object.type[n] { 
				2,3 -> {
					return (object.prop[n] & 32) 
					}
				4,8 -> {
					return (object.value[n])
					}
			}
		}	
	}

;waits for the stylus to be lifted off the panel	
	sub WaitNoTouch() {
		do {
			btn = cx16.mouse_get(&mx as ubyte)
		} until btn & %00000001 == 0 		
	}
	
;populates x,y coordinates if left mouse button pressed (a touch) and returns true, else returns false for no touch 	
	sub GetTouch() -> bool {
		btn = cx16.mouse_get(&mx as ubyte)
		
		if btn & %00000001 != 0 {
			Xt = mx
			Yt = my
			return(true)
		}
		else {
			return(false)
		}	
	}
	
;Main touch processor. Regular calls here will get the numeric name of
;screen objects that are touched, return -1 if no object is touched
;animates and manages status etc
	sub ProcessTouch() -> byte {
		byte Pt
		ubyte n
		ubyte m
		uword w
		ubyte q
		
		Pt = -1
			for n in 0 to P-1 as ubyte {
				if Xt >= object.xpos[n] { ;and Xt <= object.width[n] {
					if Yt >= object.ypos[n] { ;and Yt <= object.height[n] {
						if Xt <= object.width[n] {
							if Yt <= object.height[n] {
								if object.prop[n] & %00001000 {
									if object.prop[n] & %00000100 {
										Pt = object.id[n] as byte
										object.prop[n] = object.prop[n] | %00010000   	;touched
										when object.type[n] {								;click animation
											1 -> {											;button
												object.opt3[n] = 2
												q = lsb(object.opt2[n])
												if q == 0 {
													object.opt2[n] = q ^ 1 as uword }
												else {													
													object.opt2[n] ^= q as uword
												}
												ObjDraw(object.id[n])
											}												;end case 1
											
											2 -> {											;radio button
												for m in 0 to P as ubyte {
													if object.id[n] != object.id[m] {
														if object.type[m] == 2 {
															if object.opt1[m] == object.opt1[n] {
																object.prop[m] = object.prop[m] & %11011111
																ObjDraw(object.id[m])
															}
														}
													}
												}
												object.prop[n] = object.prop[n] | %00100000
												ObjDraw(object.id[n])												
											}												;end case 2

											3 -> {											;checkbox
												if object.prop[n] & %00100000 {
													object.prop[n] = object.prop[n] & %11011111
												}
												else {
													object.prop[n] = object.prop[n] | %00100000
												}
												ObjDraw(object.id[n])
											}												;end case 3
											
											4 -> {											;slider												
												do {
														w = object.width[n] - object.xpos[n]
														Xt = (floats.clampf(Xt as float - object.xpos[n] as float,0.0,w as float)) as uword
														w = (Xt as float/(w as float/(object.opt2[n] - object.opt1[n]) as float)) as uword
														ObjVSet(object.id[n],w)
														if object.opt3[n] {
															ubyte t
															conv.str_uw(w)
															t = ObjFind(object.opt3[n] as ubyte) as ubyte
															object.txdata[t] = conv.string_out
															ObjDraw(object.opt3[n] as ubyte)
														}
													ObjDraw(object.id[n])	
												} until GetTouch() == false	;left button released
											}												;end case 4												
										}													;end case(when structure)											
									
ra:										WaitNoTouch()										;make sure button is released
										when object.type[n] {									;release animation
											1 -> {
												object.opt3[n] = 1
												if q == 0 {
													object.opt2[n] =  q ^ 1 as uword }
												else {
													object.opt2[n] ^= q as uword
												}												
												ObjDraw(object.id[n])
											}
										} ;end when
									}
								}
							}
						}
					}
				}
			}	;end for
			return(Pt)
		}	;end processtouch()	
	

;set values of gadget by its numeric name
 sub ObjVSet(ubyte id, uword v) {
		byte n
		float lo
		float hi
		
		
		n = ObjFind(id)
		
		if n > -1 {
			when object.type[n] { 
				4,8 -> {
					lo = object.opt1[n] as float
					hi = object.opt2[n] as float
 					object.value[n] = floats.clampf(v as float,lo,hi) as uword
				}
			}
		} 
 }

 sub Frame(byte n, ubyte os) {
 	ubyte c1
 	ubyte c2
 	
 		when (object.opt3[n] & $f) {
			0 -> {							;none
				c1 = CGH
				c2 = CGH
				}
				
			1 -> {							;button style raised
				c1 = 1
				c2 = 0
				}
				
			2 -> {							;button style depressed
				c1 = 0
				c2 = 1
				}
				
			3 -> {							;white
				c1 = 1
				c2 = 1
				}
				
			4 -> {							;black
				c1 = 0
				c2 = 0
				}
				
			5 -> {							;grey (disabled)
				c1 = CGY
				c2 = CGY
				}
			}
		gfx2.line(object.xpos[n]-os,object.ypos[n]-os,object.xpos[n]-os,object.height[n]+os,c1)
		gfx2.line(object.xpos[n]-os,object.ypos[n]-os,object.width[n]+os,object.ypos[n]-os,c1)
		gfx2.line(object.width[n]+os,object.ypos[n]-os,object.width[n]+os,object.height[n]+os,c2)
		gfx2.line(object.xpos[n]-os,object.height[n]+os,object.width[n]+os,object.height[n]+os,c2)
			
 }

 sub ObjCleanup(byte n, ubyte f) {
		if f or (object.prop[n] & 64) {
			gfx2.fillrect(object.xpos[n]-1,object.ypos[n]-1,object.width[n]+1,object.height[n]+1,CGH)
		}
		object.prop[n] = object.prop[n] & $bf					;clear cleanup flag

 }

 sub ObjDraw( ubyte id) {
 		byte o
		byte n
		byte m
		uword x
		uword y
		uword w
		uword h
		uword z
		uword xx
		uword yy
	 	float nn
		uword j
		;str a
		ubyte tc				;text color
		
		n = ObjFind(id)
		if n > -1 {
			ObjCleanup(n,0)
			x = object.xpos[n]
			y = object.ypos[n]
			w = object.width[n] - x
			h = object.height[n] - y
			
			when object.type[n] {
				1 -> {															;button
					if object.prop[n] & 8 {										;visible
						gfx2.fillrect(x,y,w,h,object.opt1[n] as ubyte)
						Frame(n,0)
						if object.prop[n] & 4 {									;enabled
							z = object.opt2[n] 
						}
						else {													;ghosted
							z = 24
						}
						gfx2.text(w/2+x-8*string.length(object.txdata[n])/2,h/2+y-8/2,z as ubyte,object.txdata[n])
					}
					else {														;erase
						ObjCleanup(n,1)
						}
				}
				
				2 -> {																;radio
					if object.prop[n] & %00001000 {									;visible
						x += 5
						y += 5
						tc = 0
						if object.prop[n] & %00000100 {								;Enabled
							if object.prop[n] & %00100000 {							;set
								gfx2.disc(x,y,5,26)
								gfx2.disc(x,y,4,1)
								gfx2.disc(x,y,3,object.opt2[n] as ubyte)
		
								nn = 45.0
								while nn <= 120.0 {
									xx = (x as float + 0.5 + 5.0*floats.sin(nn)) as uword
									yy = (y as float + 0.5 + 5.0*floats.cos(nn)) as uword
									gfx2.plot(xx,yy,0)
									nn += 6.0
								}

							}
							else {														;unset
									gfx2.disc(x,y,5,26)
									gfx2.disc(x,y,4,1)
									gfx2.disc(x,y,3,29)
		
									nn = 45.0
									while nn <= 120.0 {
										xx = (x as float + 0.5 + 5.0*floats.sin(nn)) as uword
										yy = (y as float + 0.5 + 5.0*floats.cos(nn)) as uword
										gfx2.plot(xx,yy,0)
										nn += 6.0
									}
								}							
						}						
						else {																;disabled
							gfx2.disc(x,y,5,26)
							gfx2.disc(x,y,4,29)
							gfx2.disc(x,y,3,29)
							tc = 24
						}								
						gfx2.text(x+15,y+(h/2)-7,tc,object.txdata[n])
						
					}

				}
				
	
			
				3 -> {																		;checkbox 
					if object.prop[n] & %00001000 {										;visible		
						if object.prop[n] & %00000100 {									;Enabled
							tc = 1 }
						else {																;ghosted
							tc = 29
						}
						gfx2.fillrect(x,y,11,11,tc)
						gfx2.line(x,y,x,y+11,0)
						gfx2.line(x,y,x+11,y,0)
						gfx2.line(x+11,y,x+11,y+11,1)
						gfx2.line(x+11,y+11,x,y+11,1)
						
						if object.prop[n] & %00000100 {									;Enabled
							tc = 0 }
						else {																;ghosted
							tc = 24
						}
						if object.prop[n] & %00100000 {									;checked
;							gfx2.line(x+2,y+2,x+9,y+9,tc)
;							gfx2.line(x+2,y+9,x+9,y+2,tc)
							gfx2.line(x+2,y+6,x+5,y+9,tc)
							gfx2.line(x+5,y+9,x+9,y+2,tc)

							}						
						gfx2.text(x+15,y+(h/2)-2,tc,object.txdata[n])					
					}				
					else {																	;erase
						ObjCleanup(n,1) }
					}
					
				4 -> {																		;slider
					if object.prop[n] & %00001000	{										;visible
						gfx2.fillrect(x-5,y,w+11,h+1,CGH)
						y=y+(h/2)
						gfx2.line(x,y-2,x+w,y-2,0)
						gfx2.line(x,y-2,x,y+2,0)
						gfx2.line(x,y+2,x+w,y+2,1)
						gfx2.line(x+w,y+2,x+w,y-2,1)
						x = x as float + ((w as float/(object.opt2[n]-object.opt1[n]) as float)*object.value[n] as float) as uword
						y = object.ypos[n]
						;pointer
						if object.prop[n] & %00000100 {												;Enabled
							gfx2.fillrect(x-5,y,11,h,CGH)
							
							gfx2.line(x+5,y+3,x+5,y+h,0)
							gfx2.line(x+5,y+h,x-5,y+h,0)
							
							gfx2.line(x,y,x+5,y+3,1)
							
							gfx2.line(x-5,y+h,x-5,y+3,1)
							gfx2.line(x-5,y+3,x,y,1)
						}
						else {																			;disabled
							gfx2.fillrect(x-5,y,11,h,CGY)
							gfx2.line(x+5,y+3,x+5,y+h,CGH)
							gfx2.line(x+5,y+h,x-5,y+h,CGH)
							gfx2.line(x,y,x+5,y+3,CGH)
							gfx2.line(x-5,y+h,x-5,y+3,CGH)
							gfx2.line(x-5,y+3,x,y,CGH)
						}
					}
					else {																				;erase
						ObjCleanup(n,1)
						}
					}
									
					
				5 -> {																					;textbox
					if object.prop[n] & %00001000	{													;visible
						gfx2.fillrect(x,y,w+1,h+1,object.opt1[n] as ubyte)
						Frame(n,1)
						when object.opt3[n] >> 4 {
							0 -> {																		;Left justified
								gfx2.text(x,h/2+y-8/2+1,object.opt2[n] as ubyte,object.txdata[n])
								}
							1 -> {																		;Center justified
								gfx2.text(w/2+x-8*string.length(object.txdata[n])/2,h/2+y-8/2+1,object.opt2[n] as ubyte,object.txdata[n])
								}
							2 -> {																		;Right justified
								gfx2.text(object.width[n]-(8*string.length(object.txdata[n])),h/2+y-8/2+1,object.opt2[n] as ubyte,object.txdata[n])
								}
							}
						}
					else {																				;erase
						ObjCleanup(n,1)
					}
				}					
								
				8 -> {																					;progress bar
					if object.prop[n] & %00001000 {														;visible
						Frame(n,1)
						
						if object.opt3[n] & %00010000 {													;vert
							z = (h/(object.opt2[n]-object.opt1[n]))*object.value[n]
							j = object.value[n]
							gfx2.fillrect(x,y,w,h-z,CGY)
							tc = (object.opt3[n] >> 8) as ubyte
							gfx2.fillrect(x,(y+h)-z,w,z,tc)
							goto p1
						}																				
						if object.opt3[n] & %00010000 == false {																			;horz
							z = (w/(object.opt2[n]-object.opt1[n]))*object.value[n]						
							gfx2.fillrect(x+z,y,w-z,h,CGY)
							tc = (object.opt3[n] >> 8) as ubyte
							gfx2.fillrect(x,y,z,h,tc)
							}
						}
					else {																				;erase
						ObjCleanup(n,1)
					}
p1:
				}								
					
					
				9 -> {																					;frame
					Frame(n,0)
					gfx2.line(x+5,y,x+5+string.length(object.txdata[n])*8,y,CGH)
					gfx2.text(x+5,y-8/2,0,object.txdata[n])
					}					
				}
				
			}
			
		;} 
 	
 
 }
 
 sub calc(ubyte n) {
 	str num = "    "
 	
 	gfx2.fillrect(160,170,20,20,26)
 	
 	gfx2.text(160,180,0,num)
 	conv.str_ub(n)
 	
 	num = conv.string_out
 	gfx2.text(160,180,0,num)
 	
 	}
 

 


;Sets the properties of an object
;Returns -1 if not found
	sub ObjPSet(ubyte id, ubyte b) -> byte {					;id,enabled,visible,touched,Set,cleanup
		byte n
		
		n = ObjFind(id)
		if n > -1 {
			object.prop[n] = b as byte
			return(1 as byte)								;just a non negative value
		}
		return(-1)									;object not found
	}
	
;Finds the internal reference for an object from its numeric name
;Returns the object number or -1 if not found
	sub ObjFind(ubyte id) -> byte {
		ubyte n
		
		for n in 0 to main.P-1 as ubyte {
			if object.id[n] == id {
;				%asm{{
;					stp
;					}}
				return(n as byte) }						;object exists
		}
;		%asm{{
;			stp
;			}}
		return(-1)
	}	
	
;defines an object but doesn't draw anything. returns 0 if all OK.
;res=GUIObjDef(21,1,10,10,80,30,"Save",&hffggbb,,1)
	sub ObjDef(ubyte id, ubyte tp, uword x, uword y, uword w, uword h, str tx, uword g, uword c, uword d) -> ubyte {
		byte n
		
		if P > main.Objs {				;too many objects
			return(1)							
		}							
		n = ObjFind(id)
		
		if n == -1 {
			n = main.P
			main.P += 1					;define or redefine. P always points to the next free "slot"
		}
		
		object.id[n as ubyte] = id
		object.type[n as ubyte] = tp
		object.prop[n as ubyte] = 0
		object.xpos[n as ubyte] = x
		object.ypos[n as ubyte] = y
		object.opt1[n as ubyte] = g			
		object.opt2[n as ubyte] = c
		object.opt3[n as ubyte] = d
		object.value[n as ubyte] = g
		object.txdata[n as ubyte] = tx
	
		
		when tp {
			1,5,8,9 -> {									;button,textbox,progress bar,frame
				object.width[n] = x+w
				object.height[n] = y+h
				if object.opt1[n] + object.opt2[n] == 0 { 
					object.opt1[n] = CGY
					}
			}
			
			2,3	-> {										;Radio,checkbox
				object.width[n] = x + 15 + 8 * string.length(object.txdata[n])
				object.height[n] = y + 8
				}
				
			4 -> {											;Slider
				object.ypos[n] = y - 4
				object.width[n] = w ;x + w
				object.height[n] = y + 14
				}
		}
	return(0)
	}		
	





}	;end of main



; data structure for GUI objects
object {
	ubyte[] id = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]				;object unique id
	ubyte[] type = [2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2]			;type of gadget
	ubyte[] prop = [3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3]			;properties bits
	uword[] xpos = [4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4]			
	uword[] ypos = [5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5]
	uword[] width = [6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6]			;
	uword[] height = [7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7]		;
	uword[] opt1 = [8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8]				;optional parameters - min., max. , etc.
	uword[] opt2 = [9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9]
	uword[] opt3 = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]			;border type, etc.
	uword[] value = [9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9]
	str[] txdata = ["??????????????????????????????","??????????????????????????????","??????????????????????????????",
						"??????????????????????????????","??????????????????????????????","??????????????????????????????",
						"??????????????????????????????","??????????????????????????????","??????????????????????????????",	
						"??????????????????????????????","??????????????????????????????","??????????????????????????????",	
						"??????????????????????????????","??????????????????????????????","??????????????????????????????",	
						"??????????????????????????????","??????????????????????????????","??????????????????????????????",	
						"??????????????????????????????","??????????????????????????????"]	
	}

	
	
	